<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/dialogflow/v2/agent.proto

namespace Google\Cloud\Dialogflow\V2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents a conversational agent.
 *
 * Generated from protobuf message <code>google.cloud.dialogflow.v2.Agent</code>
 */
class Agent extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The project of this agent.
     * Format: `projects/<Project ID>`.
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     */
    private $parent = '';
    /**
     * Required. The name of this agent.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     */
    private $display_name = '';
    /**
     * Required. The default language of the agent as a language tag. See
     * [Language Support](https://dialogflow.com/docs/reference/language) for a
     * list of the currently supported language codes.
     * This field cannot be set by the `Update` method.
     *
     * Generated from protobuf field <code>string default_language_code = 3;</code>
     */
    private $default_language_code = '';
    /**
     * Optional. The list of all languages supported by this agent (except for the
     * `default_language_code`).
     *
     * Generated from protobuf field <code>repeated string supported_language_codes = 4;</code>
     */
    private $supported_language_codes;
    /**
     * Required. The time zone of this agent from the
     * [time zone database](https://www.iana.org/time-zones), e.g.,
     * America/New_York, Europe/Paris.
     *
     * Generated from protobuf field <code>string time_zone = 5;</code>
     */
    private $time_zone = '';
    /**
     * Optional. The description of this agent.
     * The maximum length is 500 characters. If exceeded, the request is rejected.
     *
     * Generated from protobuf field <code>string description = 6;</code>
     */
    private $description = '';
    /**
     * Optional. The URI of the agent's avatar.
     * Avatars are used throughout the Dialogflow console and in the self-hosted
     * [Web Demo](https://dialogflow.com/docs/integrations/web-demo) integration.
     *
     * Generated from protobuf field <code>string avatar_uri = 7;</code>
     */
    private $avatar_uri = '';
    /**
     * Optional. Determines whether this agent should log conversation queries.
     *
     * Generated from protobuf field <code>bool enable_logging = 8;</code>
     */
    private $enable_logging = false;
    /**
     * Optional. Determines how intents are detected from user queries.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Agent.MatchMode match_mode = 9;</code>
     */
    private $match_mode = 0;
    /**
     * Optional. To filter out false positive results and still get variety in
     * matched natural language inputs for your agent, you can tune the machine
     * learning classification threshold. If the returned score value is less than
     * the threshold value, then a fallback intent is be triggered or, if there
     * are no fallback intents defined, no intent will be triggered. The score
     * values range from 0.0 (completely uncertain) to 1.0 (completely certain).
     * If set to 0.0, the default of 0.3 is used.
     *
     * Generated from protobuf field <code>float classification_threshold = 10;</code>
     */
    private $classification_threshold = 0.0;

    public function __construct() {
        \GPBMetadata\Google\Cloud\Dialogflow\V2\Agent::initOnce();
        parent::__construct();
    }

    /**
     * Required. The project of this agent.
     * Format: `projects/<Project ID>`.
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The project of this agent.
     * Format: `projects/<Project ID>`.
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required. The name of this agent.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Required. The name of this agent.
     *
     * Generated from protobuf field <code>string display_name = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Required. The default language of the agent as a language tag. See
     * [Language Support](https://dialogflow.com/docs/reference/language) for a
     * list of the currently supported language codes.
     * This field cannot be set by the `Update` method.
     *
     * Generated from protobuf field <code>string default_language_code = 3;</code>
     * @return string
     */
    public function getDefaultLanguageCode()
    {
        return $this->default_language_code;
    }

    /**
     * Required. The default language of the agent as a language tag. See
     * [Language Support](https://dialogflow.com/docs/reference/language) for a
     * list of the currently supported language codes.
     * This field cannot be set by the `Update` method.
     *
     * Generated from protobuf field <code>string default_language_code = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setDefaultLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->default_language_code = $var;

        return $this;
    }

    /**
     * Optional. The list of all languages supported by this agent (except for the
     * `default_language_code`).
     *
     * Generated from protobuf field <code>repeated string supported_language_codes = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSupportedLanguageCodes()
    {
        return $this->supported_language_codes;
    }

    /**
     * Optional. The list of all languages supported by this agent (except for the
     * `default_language_code`).
     *
     * Generated from protobuf field <code>repeated string supported_language_codes = 4;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSupportedLanguageCodes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->supported_language_codes = $arr;

        return $this;
    }

    /**
     * Required. The time zone of this agent from the
     * [time zone database](https://www.iana.org/time-zones), e.g.,
     * America/New_York, Europe/Paris.
     *
     * Generated from protobuf field <code>string time_zone = 5;</code>
     * @return string
     */
    public function getTimeZone()
    {
        return $this->time_zone;
    }

    /**
     * Required. The time zone of this agent from the
     * [time zone database](https://www.iana.org/time-zones), e.g.,
     * America/New_York, Europe/Paris.
     *
     * Generated from protobuf field <code>string time_zone = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setTimeZone($var)
    {
        GPBUtil::checkString($var, True);
        $this->time_zone = $var;

        return $this;
    }

    /**
     * Optional. The description of this agent.
     * The maximum length is 500 characters. If exceeded, the request is rejected.
     *
     * Generated from protobuf field <code>string description = 6;</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Optional. The description of this agent.
     * The maximum length is 500 characters. If exceeded, the request is rejected.
     *
     * Generated from protobuf field <code>string description = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Optional. The URI of the agent's avatar.
     * Avatars are used throughout the Dialogflow console and in the self-hosted
     * [Web Demo](https://dialogflow.com/docs/integrations/web-demo) integration.
     *
     * Generated from protobuf field <code>string avatar_uri = 7;</code>
     * @return string
     */
    public function getAvatarUri()
    {
        return $this->avatar_uri;
    }

    /**
     * Optional. The URI of the agent's avatar.
     * Avatars are used throughout the Dialogflow console and in the self-hosted
     * [Web Demo](https://dialogflow.com/docs/integrations/web-demo) integration.
     *
     * Generated from protobuf field <code>string avatar_uri = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setAvatarUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->avatar_uri = $var;

        return $this;
    }

    /**
     * Optional. Determines whether this agent should log conversation queries.
     *
     * Generated from protobuf field <code>bool enable_logging = 8;</code>
     * @return bool
     */
    public function getEnableLogging()
    {
        return $this->enable_logging;
    }

    /**
     * Optional. Determines whether this agent should log conversation queries.
     *
     * Generated from protobuf field <code>bool enable_logging = 8;</code>
     * @param bool $var
     * @return $this
     */
    public function setEnableLogging($var)
    {
        GPBUtil::checkBool($var);
        $this->enable_logging = $var;

        return $this;
    }

    /**
     * Optional. Determines how intents are detected from user queries.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Agent.MatchMode match_mode = 9;</code>
     * @return int
     */
    public function getMatchMode()
    {
        return $this->match_mode;
    }

    /**
     * Optional. Determines how intents are detected from user queries.
     *
     * Generated from protobuf field <code>.google.cloud.dialogflow.v2.Agent.MatchMode match_mode = 9;</code>
     * @param int $var
     * @return $this
     */
    public function setMatchMode($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Dialogflow\V2\Agent_MatchMode::class);
        $this->match_mode = $var;

        return $this;
    }

    /**
     * Optional. To filter out false positive results and still get variety in
     * matched natural language inputs for your agent, you can tune the machine
     * learning classification threshold. If the returned score value is less than
     * the threshold value, then a fallback intent is be triggered or, if there
     * are no fallback intents defined, no intent will be triggered. The score
     * values range from 0.0 (completely uncertain) to 1.0 (completely certain).
     * If set to 0.0, the default of 0.3 is used.
     *
     * Generated from protobuf field <code>float classification_threshold = 10;</code>
     * @return float
     */
    public function getClassificationThreshold()
    {
        return $this->classification_threshold;
    }

    /**
     * Optional. To filter out false positive results and still get variety in
     * matched natural language inputs for your agent, you can tune the machine
     * learning classification threshold. If the returned score value is less than
     * the threshold value, then a fallback intent is be triggered or, if there
     * are no fallback intents defined, no intent will be triggered. The score
     * values range from 0.0 (completely uncertain) to 1.0 (completely certain).
     * If set to 0.0, the default of 0.3 is used.
     *
     * Generated from protobuf field <code>float classification_threshold = 10;</code>
     * @param float $var
     * @return $this
     */
    public function setClassificationThreshold($var)
    {
        GPBUtil::checkFloat($var);
        $this->classification_threshold = $var;

        return $this;
    }

}

